## ares 147+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.28...4.1)

include("${CMAKE_CURRENT_SOURCE_DIR}/cmake/common/bootstrap.cmake" NO_POLICY_SCOPE)

project(ares VERSION ${ARES_VERSION_CANONICAL})

include(compilerconfig)
include(defaults)
include(helpers)

add_subdirectory(thirdparty)

add_subdirectory(nall/nall)
add_subdirectory(libco)
add_subdirectory(ruby)
add_subdirectory(hiro)

# gersemi: off
set(
  ARES_CORES
  a26 fc sfc sg ms md ps1 pce ng msx cv myvision gb gba ws ngp spec n64
  CACHE STRING "List of systems to be built by the project"
)
# gersemi: on

add_subdirectory(ares)
add_subdirectory(mia)
add_subdirectory(desktop-ui)

option(ARES_BUILD_OPTIONAL_TARGETS "Include supplemental tools and tests" OFF)

if(ARES_BUILD_OPTIONAL_TARGETS)
  add_subdirectory(tests/arm7tdmi)
  add_subdirectory(tests/i8080)
  add_subdirectory(tests/m68000)
  if(HIRO_BACKEND STREQUAL "GTK3")
    add_subdirectory(tools/genius)
  else()
    target_disable_subproject(genius "genius (database editor)")
  endif()
  add_subdirectory(tools/mame2bml)
else()
  target_disable_subproject(arm7tdmi "arm7tdmi processor test harness")
  target_disable_subproject(i8080 "i8080 processor test harness")
  target_disable_subproject(m68000 "m68000 processor test harness")
  target_disable_subproject(mame2bml "mame2bml (MAME manifest converter)")
  target_disable_subproject(genius "genius (database editor)")
endif()

add_subdirectory(tools/sourcery)

message_configuration()

add_subdirectory(.github)
add_subdirectory(cmake)
return()

=== .github/CMakeLists.txt ===
# dummy GitHub target used to enable editing of GitHub files within generated IDE projects

add_library(.github INTERFACE)

set(.github_sources
    ISSUE_TEMPLATE/bug_report.md
    ISSUE_TEMPLATE/feature_request.md
    ISSUE_TEMPLATE/game-issue-report.md
    scripts/build_macos.sh
    scripts/build_ubuntu.sh
    scripts/build_windows.sh
    scripts/package_artifacts.sh
    workflows/build-aux.yml
    workflows/build.yml
    workflows/pr.yml
    workflows/push.yml
    workflows/release.yml
)

target_sources(
  .github
  PRIVATE
  ${.github_sources}
  ../.gitignore
  ../.gitattributes
  ../README.md
  ../LICENSE
)

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${.github_sources})

=== ares/CMakeLists.txt ===
add_library(ares STATIC ares/ares.cpp ares/memory/fixed-allocator.cpp)

configure_file(ares/ares.cpp.in ares/ares.cpp @ONLY)

add_library(ares::ares ALIAS ares)

option(ARES_PROFILE_ACCURACY "Build to prefer emulation accuracy over performance in certain specific areas" OFF)
option(ARES_PRECOMPILE_HEADERS "Precompile ares/ares.hpp header for performance" OFF)
option(
  ARES_UNITY_CORES
  "\
Build each core as one translation unit. Decreases cold build times but increases incremental build times. Slightly \
increases performance.
"
  OFF
)

add_sourcery_command(ares ares/resource)

if(ARES_PRECOMPILE_HEADERS)
  target_precompile_headers(ares PRIVATE "$<$<COMPILE_LANGUAGE:CXX>:ares/ares.hpp>")
endif()

target_link_libraries(ares PRIVATE libco ares::nall::headers $<$<BOOL:${ARES_ENABLE_CHD}>:chdr-static> PUBLIC sljit)

if(ARES_PROFILE_ACCURACY)
  target_compile_definitions(ares PUBLIC PROFILE_ACCURACY)
else()
  target_compile_definitions(ares PUBLIC PROFILE_PERFORMANCE)
endif()

target_sources(
  ares
  PRIVATE ares/ares.cpp ares/ares.cpp.in ares/ares.hpp ares/inline.hpp ares/platform.hpp ares/random.hpp ares/types.hpp
)

target_sources(
  ares
  PRIVATE
    ares/debug/debug.cpp
    ares/debug/debug.hpp
    ares/memory/fixed-allocator.cpp
    ares/memory/fixed-allocator.hpp
    ares/memory/memory.hpp
    ares/memory/readable.hpp
    ares/memory/writable.hpp
)

target_sources(
  ares
  PRIVATE ares/scheduler/scheduler.cpp ares/scheduler/scheduler.hpp ares/scheduler/thread.cpp ares/scheduler/thread.hpp
)

target_sources(
  ares
  PRIVATE
    ares/node/attribute.hpp
    ares/node/class.hpp
    ares/node/node.cpp
    ares/node/node.hpp
    ares/node/object.hpp
    ares/node/peripheral.hpp
    ares/node/port.hpp
    ares/node/system.hpp
)

target_sources(ares PRIVATE ares/node/audio/audio.hpp ares/node/audio/stream.cpp ares/node/audio/stream.hpp)

target_sources(ares PRIVATE ares/node/component/component.hpp ares/node/component/real-time-clock.hpp)

target_sources(
  ares
  PRIVATE
    ares/node/input/axis.hpp
    ares/node/input/button.hpp
    ares/node/input/input.hpp
    ares/node/input/rumble.hpp
    ares/node/input/trigger.hpp
)

target_sources(
  ares
  PRIVATE
    ares/node/setting/boolean.hpp
    ares/node/setting/integer.hpp
    ares/node/setting/natural.hpp
    ares/node/setting/real.hpp
    ares/node/setting/setting.hpp
    ares/node/setting/string.hpp
)

target_sources(
  ares
  PRIVATE
    ares/node/video/screen.cpp
    ares/node/video/screen.hpp
    ares/node/video/sprite.cpp
    ares/node/video/sprite.hpp
    ares/node/video/video.hpp
)

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX OR OS_FREEBSD OR OS_OPENBSD)
  include(cmake/os-linux.cmake)
endif()

macro(ares_components)
  list(APPEND ares.components ${ARGV})
  set(ares.components ${ares.components} PARENT_SCOPE)
endmacro()

macro(ares_add_sources)
  set(options "")
  set(oneValueArgs CORE)
  set(multiValueArgs PRIMARY INCLUDED UNITY)
  cmake_parse_arguments(AAS "" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  target_sources(ares PRIVATE ${AAS_INCLUDED} ${AAS_PRIMARY})

  if(ARES_UNITY_CORES)
    list(APPEND AAS_INCLUDED ${AAS_PRIMARY})
    target_sources(ares PRIVATE ${AAS_UNITY})
  endif()

  foreach(arg IN ITEMS ${AAS_INCLUDED})
    list(APPEND ARES_HEADER_SOURCES "${AAS_CORE}/${arg}")
  endforeach()
  set(ARES_HEADER_SOURCES ${ARES_HEADER_SOURCES} PARENT_SCOPE)
endmacro()

list(TRANSFORM ARES_CORES STRIP)

if(a26 IN_LIST ARES_CORES)
  enable_core("Atari 2600")
  add_subdirectory(a26)
else()
  disable_core("Atari 2600")
endif()

if(fc IN_LIST ARES_CORES)
  enable_core("NES / Famicom")
  add_subdirectory(fc)
else()
  disable_core("NES / Famicom")
endif()

if(sfc IN_LIST ARES_CORES)
  enable_core("SNES / Super Famicom")
  add_subdirectory(sfc)
else()
  disable_core("SNES / Super Famicom")
endif()

if(n64 IN_LIST ARES_CORES)
  enable_core("Nintendo 64")
  add_subdirectory(n64)
else()
  disable_core("Nintendo 64")
endif()

if(sg IN_LIST ARES_CORES)
  enable_core("Sega SG-1000")
  add_subdirectory(sg)
else()
  disable_core("Sega SG-1000")
endif()

if(ms IN_LIST ARES_CORES)
  enable_core("Sega Master System / Mark III")
  add_subdirectory(ms)
else()
  disable_core("Sega Master System / Mark III")
endif()

if(md IN_LIST ARES_CORES)
  enable_core("Sega Mega Drive / Genesis")
  add_subdirectory(md)
else()
  disable_core("Sega Mega Drive / Genesis")
endif()

if(saturn IN_LIST ARES_CORES)
  enable_core("Sega Saturn")
  add_subdirectory(saturn)
else()
  disable_core("Sega Saturn")
endif()

if(ps1 IN_LIST ARES_CORES)
  enable_core("PlayStation")
  add_subdirectory(ps1)
else()
  disable_core("Playstation")
endif()

if(pce IN_LIST ARES_CORES)
  enable_core("PC-Engine / TurboGrafx")
  add_subdirectory(pce)
else()
  disable_core("PC-Engine / TurboGrafx")
endif()

if(msx IN_LIST ARES_CORES)
  enable_core("Microsoft MSX")
  add_subdirectory(msx)
else()
  disable_core("Microsoft MSX")
endif()

if(cv IN_LIST ARES_CORES)
  enable_core("ColecoVision")
  add_subdirectory(cv)
else()
  disable_core("ColecoVision")
endif()

if(myvision IN_LIST ARES_CORES)
  enable_core("My Vision")
  add_subdirectory(myvision)
else()
  disable_core("My Vision")
endif()

if(gb IN_LIST ARES_CORES)
  enable_core("Game Boy / Game Boy Color")
  add_subdirectory(gb)
else()
  disable_core("Game Boy / Game Boy Color")
endif()

if(gba IN_LIST ARES_CORES)
  enable_core("Game Boy Advance")
  add_subdirectory(gba)
else()
  disable_core("Game Boy Advance")
endif()

if(ws IN_LIST ARES_CORES)
  enable_core("WonderSwan / WonderSwan Color")
  add_subdirectory(ws)
else()
  disable_core("WonderSwan / WonderSwan Color")
endif()

if(ng IN_LIST ARES_CORES)
  enable_core("Neo Geo (AES/MVS)")
  add_subdirectory(ng)
else()
  disable_core("Neo Geo (AES/MVS)")
endif()

if(ngp IN_LIST ARES_CORES)
  enable_core("Neo Geo Pocket / Neo Geo Pocket Color")
  add_subdirectory(ngp)
else()
  disable_core("Neo Geo Pocket / Neo Geo Pocket Color")
endif()

if(spec IN_LIST ARES_CORES)
  enable_core("ZX Spectrum")
  add_subdirectory(spec)
else()
  disable_core("ZX Spectrum")
endif()

add_subdirectory(component)

foreach(c IN LISTS ARES_CORES)
  # target_enable_feature(ares "${c} core" CORE_$<UPPER_CASE:${c}>)
  target_compile_definitions(ares PUBLIC CORE_$<UPPER_CASE:${c}>)
endforeach()

get_target_property(ares_SOURCES ares SOURCES)

set_source_files_properties(
  ares
  ares/debug/debug.cpp
  ares/node/audio/stream.cpp
  ares/node/node.cpp
  ares/node/video/screen.cpp
  ares/node/video/sprite.cpp
  ares/scheduler/thread.cpp
  ares/scheduler/scheduler.cpp
  PROPERTIES HEADER_FILE_ONLY TRUE
)

set_source_files_properties(
  n64/vulkan/parallel-rdp/vulkan/shader.cpp
  n64/vulkan/parallel-rdp/vulkan/descriptor_set.cpp
  n64/vulkan/parallel-rdp/vulkan/device.cpp
  n64/vulkan/parallel-rdp/vulkan/command_buffer.cpp
  n64/vulkan/parallel-rdp/vulkan/render_pass.cpp
  n64/vulkan/parallel-rdp/vulkan/context.cpp
  n64/vulkan/parallel-rdp/vulkan/memory_allocator.cpp
  n64/vulkan/parallel-rdp/vulkan/semaphore.cpp
  n64/vulkan/parallel-rdp/util/logging.cpp
  n64/vulkan/parallel-rdp/util/environment.cpp
  n64/vulkan/parallel-rdp/util/thread_name.cpp
  n64/vulkan/parallel-rdp/util/timer.cpp
  PROPERTIES SKIP_PRECOMPILE_HEADERS ON
)

target_sources(ares PRIVATE cmake/os-macos.cmake cmake/os-windows.cmake cmake/os-linux.cmake)

set_source_files_properties(ares ${ARES_HEADER_SOURCES} PROPERTIES HEADER_FILE_ONLY TRUE)

set_source_files_properties(ares ares/ares.cpp ares/memory/fixed-allocator.cpp PROPERTIES HEADER_FILE_ONLY FALSE)

target_include_directories(ares INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${ares_SOURCES})

=== cmake/CMakeLists.txt ===
# dummy cmake target used to enable editing of CMake files within generated IDE projects

add_library(cmake INTERFACE)

set(
  cmake_sources
  common/bootstrap.cmake
  common/dependencies_common.cmake
  common/ccache.cmake
  common/compiler_common.cmake
  common/helpers_common.cmake
  common/osconfig.cmake
  common/versionconfig.cmake
  finders/Findlibrashader.cmake
  finders/Findslang_shaders.cmake
  finders/FindMoltenVK.cmake
  finders/FindSDL.cmake
  finders/FindGTK.cmake
  finders/FindAO.cmake
  finders/FindOSS.cmake
  finders/FindPulseAudio.cmake
  finders/Findudev.cmake
  finders/Findusbhid.cmake
  macos/dependencies.cmake
  macos/compilerconfig.cmake
  macos/defaults.cmake
  macos/helpers.cmake
  macos/xcode.cmake
  windows/compilerconfig.cmake
  windows/defaults.cmake
  windows/dependencies.cmake
  windows/helpers.cmake
  linux/compilerconfig.cmake
  linux/defaults.cmake
  linux/helpers.cmake
  linux/dependencies.cmake
)

target_sources(cmake PRIVATE ${cmake_sources} ../CMakePresets.json ../deps.json ../.gersemirc)

if(TARGET clean-all)
  set_target_properties(clean-all PROPERTIES FOLDER cmake/unused PREFIX "")
endif()

if(TARGET uninstall)
  set_target_properties(uninstall PROPERTIES FOLDER cmake/unused PREFIX "")
endif()

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${cmake_sources})

=== desktop-ui/CMakeLists.txt ===
add_executable(
  desktop-ui
  desktop-ui.cpp
  resource/resource.cpp
  input/input.cpp
  emulator/emulator.cpp
  game-browser/game-browser.cpp
  program/program.cpp
  presentation/presentation.cpp
  settings/settings.cpp
  tools/tools.cpp
)

target_sources(desktop-ui PRIVATE cmake/sources.cmake cmake/os-macos.cmake cmake/os-linux.cmake cmake/os-windows.cmake)

include(cmake/sources.cmake)

get_target_property(desktop-ui_SOURCES desktop-ui SOURCES)

set_source_files_properties(desktop-ui ${desktop-ui_SOURCES} PROPERTIES HEADER_FILE_ONLY TRUE)

set_source_files_properties(
  desktop-ui
  desktop-ui.cpp
  resource/resource.cpp
  input/input.cpp
  emulator/emulator.cpp
  game-browser/game-browser.cpp
  program/program.cpp
  presentation/presentation.cpp
  settings/settings.cpp
  tools/tools.cpp
  PROPERTIES HEADER_FILE_ONLY FALSE
)

if(ARES_ENABLE_LIBRASHADER)
  find_package(slang_shaders)
endif()

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX OR OS_FREEBSD OR OS_OPENBSD)
  include(cmake/os-linux.cmake)
endif()

target_include_directories(desktop-ui PRIVATE ${CMAKE_SOURCE_DIR})
target_link_libraries(
  desktop-ui
  PRIVATE ares::ruby ares::hiro ares::ares ares::mia ares::nall
)

if(ARES_ENABLE_CHD)
  target_link_libraries(desktop-ui PRIVATE chdr-static)
endif()

set_target_properties(desktop-ui PROPERTIES OUTPUT_NAME ares)

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${desktop-ui_SOURCES})

add_sourcery_command(desktop-ui resource)

ares_configure_executable(desktop-ui)

=== hiro/CMakeLists.txt ===
add_library(hiro STATIC)
add_library(ares::hiro ALIAS hiro)

target_link_libraries(hiro PRIVATE ares::nall::headers)

include(cmake/sources.cmake)

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX OR OS_FREEBSD OR OS_OPENBSD)
  include(cmake/os-linux.cmake)
endif()

add_sourcery_command(hiro resource)

target_include_directories(hiro PRIVATE ${CMAKE_SOURCE_DIR})

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${hiro_SOURCES})

=== mia/CMakeLists.txt ===
add_library(mia STATIC mia.cpp mia.hpp resource/resource.cpp)
add_library(ares::mia ALIAS mia)

add_sourcery_command(mia resource)

if(ARES_ENABLE_CHD)
  target_compile_definitions(mia PUBLIC ARES_ENABLE_CHD)
  target_enable_feature(mia "CHD format support via libchdr")
else()
  target_disable_feature(mia "CHD format support via libchdr")
endif()

target_sources(
  mia
  PRIVATE
    resource/resource.hpp
    medium/arcade.cpp
    medium/atari-2600.cpp
    medium/bs-memory.cpp
    medium/colecovision.cpp
    medium/famicom-disk-system.cpp
    medium/famicom.cpp
    medium/game-boy-advance.cpp
    medium/game-boy-color.cpp
    medium/game-boy.cpp
    medium/game-gear.cpp
    medium/mame.cpp
    medium/master-system.cpp
    medium/medium.cpp
    medium/medium.hpp
    medium/mega-32x.cpp
    medium/mega-cd.cpp
    medium/mega-ld.cpp
    medium/mega-drive.cpp
    medium/msx.cpp
    medium/msx2.cpp
    medium/myvision.cpp
    medium/neo-geo-crypt.hpp
    medium/neo-geo-pocket-color.cpp
    medium/neo-geo-pocket.cpp
    medium/neo-geo.cpp
    medium/nintendo-64.cpp
    medium/nintendo-64dd.cpp
    medium/pc-engine-cd.cpp
    medium/pc-engine-ld.cpp
    medium/pc-engine.cpp
    medium/playstation.cpp
    medium/pocket-challenge-v2.cpp
    medium/saturn.cpp
    medium/sc-3000.cpp
    medium/sg-1000.cpp
    medium/sufami-turbo.cpp
    medium/super-famicom.cpp
    medium/supergrafx.cpp
    medium/wonderswan-color.cpp
    medium/wonderswan.cpp
    medium/zx-spectrum.cpp
)

target_sources(mia PRIVATE pak/pak.cpp pak/pak.hpp)

target_sources(
  mia
  PRIVATE
    program/game-importer.cpp
    program/game-importer.hpp
    program/game-manager.cpp
    program/game-manager.hpp
    program/home.cpp
    program/home.hpp
    program/program.cpp
    program/program.hpp
    program/system-selection.cpp
    program/system-selection.hpp
)

target_sources(mia PRIVATE settings/settings.cpp settings/settings.hpp)

target_sources(
  mia
  PRIVATE
    system/arcade.cpp
    system/atari-2600.cpp
    system/colecovision.cpp
    system/famicom.cpp
    system/game-boy-advance.cpp
    system/game-boy-color.cpp
    system/game-boy.cpp
    system/game-gear.cpp
    system/master-system.cpp
    system/mega-32x.cpp
    system/mega-cd-32x.cpp
    system/mega-cd.cpp
    system/mega-ld.cpp
    system/mega-drive.cpp
    system/msx.cpp
    system/msx2.cpp
    system/myvision.cpp
    system/neo-geo-aes.cpp
    system/neo-geo-mvs.cpp
    system/neo-geo-pocket-color.cpp
    system/neo-geo-pocket.cpp
    system/nintendo-64.cpp
    system/nintendo-64dd.cpp
    system/pc-engine.cpp
    system/pc-engine-ld.cpp
    system/playstation.cpp
    system/pocket-challenge-v2.cpp
    system/saturn.cpp
    system/sc-3000.cpp
    system/sg-1000.cpp
    system/super-famicom.cpp
    system/supergrafx.cpp
    system/system.cpp
    system/system.hpp
    system/wonderswan-color.cpp
    system/wonderswan.cpp
    system/zx-spectrum-128.cpp
    system/zx-spectrum.cpp
)

target_compile_definitions(mia PRIVATE MIA_LIBRARY)

target_include_directories(mia PRIVATE ${CMAKE_SOURCE_DIR})
target_include_directories(mia PRIVATE ${CMAKE_SOURCE_DIR}/thirdparty)
target_link_libraries(mia PRIVATE ares::ares ares::nall::headers tzxfile $<$<BOOL:${ARES_ENABLE_CHD}>:chdr-static>)

if(ARES_BUILD_OPTIONAL_TARGETS)
  add_executable(mia-ui mia.cpp resource/resource.cpp)

  target_include_directories(mia-ui PRIVATE ${CMAKE_SOURCE_DIR})
  target_link_libraries(
    mia-ui
    PRIVATE
      ares::hiro
      ares::ares
      ares::nall
      tzxfile
      "$<$<PLATFORM_ID:Darwin>:$<LINK_LIBRARY:FRAMEWORK,Carbon.framework>>"
      "$<$<PLATFORM_ID:Darwin>:$<LINK_LIBRARY:FRAMEWORK,IOKit.framework>>"
      "$<$<PLATFORM_ID:Darwin>:$<LINK_LIBRARY:FRAMEWORK,Security.framework>>"
      "$<$<PLATFORM_ID:Darwin>:mia>"
  )

  if(WIN32)
    target_sources(mia-ui PRIVATE resource/mia.rc resource/mia.Manifest)
  endif()

  set_target_properties(
    mia-ui
    PROPERTIES
      OUTPUT_NAME mia
      MACOSX_BUNDLE TRUE
      MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_BINARY_DIR}/mia.plist"
      XCODE_EMBED_FRAMEWORKS_REMOVE_HEADERS_ON_COPY YES
      XCODE_EMBED_FRAMEWORKS_CODE_SIGN_ON_COPY YES
      XCODE_EMBED_PLUGINS_REMOVE_HEADERS_ON_COPY YES
      XCODE_EMBED_PLUGINS_CODE_SIGN_ON_COPY YES
  )
  if(OS_MACOS)
    set_target_xcode_properties(
      mia-ui
      PROPERTIES PRODUCT_BUNDLE_IDENTIFIER dev.ares.mia
                 PRODUCT_NAME mia
                 ASSETCATALOG_COMPILER_APPICON_NAME AppIcon
                 MARKETING_VERSION ${ARES_VERSION}
                 GENERATE_INFOPLIST_FILE YES
                 CLANG_ENABLE_OBJC_ARC YES
                 INFOPLIST_KEY_CFBundleDisplayName "mia"
                 INFOPLIST_KEY_NSHumanReadableCopyright "(c) 2004-${CURRENT_YEAR} ares team, Near et. al."
    )
  endif()
  ares_configure_executable(mia-ui)
  target_enable_subproject(mia-ui "mia (manifest generator) standalone frontend")
  set_target_properties(mia-ui PROPERTIES FOLDER tools PREFIX "")
else()
  target_disable_subproject(mia-ui "mia (manifest generator) standalone frontend")
endif()

get_target_property(mia_SOURCES mia SOURCES)

set_source_files_properties(mia ${mia_SOURCES} PROPERTIES HEADER_FILE_ONLY TRUE)

set_source_files_properties(mia mia.cpp resource/resource.cpp PROPERTIES HEADER_FILE_ONLY FALSE)

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${mia_SOURCES})

=== ruby/CMakeLists.txt ===
add_library(ruby STATIC)
add_library(ares::ruby ALIAS ruby)

option(ARES_ENABLE_LIBRASHADER "Configure with librashader and slang shaders" ON)

if(OS_MACOS)
  target_sources(ruby PRIVATE ruby.mm)
else()
  target_sources(ruby PRIVATE ruby.cpp)
endif()

target_sources(ruby PRIVATE ruby.hpp)

target_sources(ruby PRIVATE audio/audio.cpp audio/audio.hpp audio/sdl.cpp)

target_sources(ruby PRIVATE input/input.cpp input/input.hpp input/sdl.cpp)

target_include_directories(ruby PRIVATE ${CMAKE_SOURCE_DIR}/thirdparty)

target_sources(
  ruby
  PRIVATE
    video/video.cpp
    video/video.hpp
    video/opengl/bind.hpp
    video/opengl/main.hpp
    video/opengl/opengl.hpp
    video/opengl/surface.hpp
    video/opengl/texture.hpp
    video/opengl/utility.hpp
)

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX)
  include(cmake/os-linux.cmake)
elseif(OS_FREEBSD OR OS_OPENBSD)
  include(cmake/os-freebsd.cmake)
endif()

target_sources(ruby PRIVATE cmake/os-macos.cmake cmake/os-windows.cmake cmake/os-linux.cmake cmake/os-freebsd.cmake)

target_link_libraries(ruby PRIVATE ares::nall::headers)

target_include_directories(ruby PRIVATE ${CMAKE_SOURCE_DIR})

get_target_property(ruby_SOURCES ruby SOURCES)

set_source_files_properties(ruby ${ruby_SOURCES} PROPERTIES HEADER_FILE_ONLY TRUE)

if(${CMAKE_SYSTEM_NAME} STREQUAL Darwin)
  set_source_files_properties(ruby ruby.mm PROPERTIES HEADER_FILE_ONLY FALSE)
else()
  set_source_files_properties(ruby ruby.cpp PROPERTIES HEADER_FILE_ONLY FALSE)
endif()

source_group(TREE ${CMAKE_CURRENT_SOURCE_DIR} FILES ${ruby_SOURCES})

=== thirdparty/CMakeLists.txt ===
add_library(sljit STATIC sljit/sljit_src/sljitLir.c)

target_include_directories(sljit PUBLIC ../thirdparty)
target_compile_definitions(sljit PUBLIC SLJIT_HAVE_CONFIG_PRE=1 SLJIT_HAVE_CONFIG_POST=1)
target_compile_options(sljit PRIVATE $<$<COMPILE_LANG_AND_ID:C,AppleClang,Clang,GNU>:-Wno-conditional-uninitialized>)

option(ARES_ENABLE_CHD "Enable CHD format support via libchdr" ON)

if(ARES_ENABLE_CHD)
  # lzma
  add_subdirectory(libchdr/deps/lzma-24.05 EXCLUDE_FROM_ALL)
  list(APPEND CHDR_LIBS lzma)
  list(APPEND CHDR_INCLUDES lzma)

  if(OS_MACOS)
    option(WITH_SYSTEM_ZLIB "Use system zlib" ON)
  endif()
  # zlib
  if(WITH_SYSTEM_ZLIB)
    find_package(ZLIB REQUIRED)
    list(APPEND PLATFORM_LIBS ZLIB::ZLIB)
  else()
    option(ZLIB_BUILD_EXAMPLES "Enable Zlib Examples" OFF)
    add_subdirectory(libchdr/deps/zlib-1.3.1 EXCLUDE_FROM_ALL)
    set_target_properties(
      zlibstatic
      PROPERTIES POSITION_INDEPENDENT_CODE ON FOLDER thirdparty PREFIX ""
    )
    list(APPEND CHDR_LIBS zlibstatic)
  endif()

  # zstd
  option(ZSTD_BUILD_SHARED "BUILD SHARED LIBRARIES" OFF)
  option(ZSTD_BUILD_PROGRAMS "BUILD PROGRAMS" OFF)
  add_subdirectory(libchdr/deps/zstd-1.5.6/build/cmake EXCLUDE_FROM_ALL)
  list(APPEND CHDR_LIBS libzstd_static)
  #--------------------------------------------------
  # chdr
  #--------------------------------------------------

  set(
    CHDR_SOURCES
    libchdr/src/libchdr_bitstream.c
    libchdr/src/libchdr_cdrom.c
    libchdr/src/libchdr_chd.c
    libchdr/src/libchdr_flac.c
    libchdr/src/libchdr_huffman.c
  )

  list(APPEND CHDR_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/libchdr/include)

  add_library(chdr-static STATIC ${CHDR_SOURCES})
  target_include_directories(chdr-static PUBLIC ${CHDR_INCLUDES} PUBLIC libchdr/include)
  target_link_libraries(chdr-static PRIVATE ${CHDR_LIBS} ${PLATFORM_LIBS})
  target_compile_options(
    chdr-static
    PRIVATE $<$<CXX_COMPILER_ID:Clang,AppleClang>:-Wno-unreachable-code -Wno-unused-function>
  )
endif()

add_library(
  tzxfile
  STATIC
  TZXFile/TZXAudioGenerator.cpp
  TZXFile/TZXBlock.cpp
  TZXFile/TZXBlockArchiveInfo.cpp
  TZXFile/TZXBlockCustomInfo.cpp
  TZXFile/TZXBlockGroupEnd.cpp
  TZXFile/TZXBlockGroupStart.cpp
  TZXFile/TZXBlockHardwareType.cpp
  TZXFile/TZXBlockLoopEnd.cpp
  TZXFile/TZXBlockLoopStart.cpp
  TZXFile/TZXBlockMessage.cpp
  TZXFile/TZXBlockPause.cpp
  TZXFile/TZXBlockPulseSequence.cpp
  TZXFile/TZXBlockPureData.cpp
  TZXFile/TZXBlockPureTone.cpp
  TZXFile/TZXBlockStandardSpeedData.cpp
  TZXFile/TZXBlockStopTheTape48K.cpp
  TZXFile/TZXBlockTextDescription.cpp
  TZXFile/TZXBlockTurboSpeedData.cpp
  TZXFile/TZXFile.cpp
)

target_include_directories(tzxfile PUBLIC ../thirdparty/TZXFile)

add_library(
  ymfm
  STATIC
  ymfm/src/ymfm_adpcm.cpp
  ymfm/src/ymfm_misc.cpp
  ymfm/src/ymfm_opl.cpp
  ymfm/src/ymfm_opm.cpp
  ymfm/src/ymfm_opn.cpp
  ymfm/src/ymfm_opq.cpp
  ymfm/src/ymfm_opz.cpp
  ymfm/src/ymfm_pcm.cpp
  ymfm/src/ymfm_ssg.cpp
)

target_include_directories(ymfm PUBLIC ../thirdparty/ymfm/src)

target_compile_options(ymfm PRIVATE $<$<CXX_COMPILER_ID:Clang,AppleClang>:-Wno-unreachable-code>)

add_library(qon STATIC qon/qon.cpp)

set_target_properties(ymfm PROPERTIES FOLDER thirdparty PREFIX "")
set_target_properties(tzxfile PROPERTIES FOLDER thirdparty PREFIX "")
set_target_properties(sljit PROPERTIES FOLDER thirdparty PREFIX "")
if(ARES_ENABLE_CHD)
  set_target_properties(chdr-static PROPERTIES FOLDER thirdparty PREFIX "")
  if(NOT WITH_SYSTEM_ZLIB)
    set_target_properties(zlib PROPERTIES FOLDER thirdparty PREFIX "")
  endif()
  set_target_properties(lzma PROPERTIES FOLDER thirdparty PREFIX "")
  set_target_properties(libzstd_static PROPERTIES FOLDER thirdparty PREFIX "")
endif()
set_target_properties(qon PROPERTIES FOLDER thirdparty PREFIX "")

=== ares/a26/CMakeLists.txt ===
ares_components(mos6502)

ares_add_sources(
  CORE #
    a26
  UNITY #
    a26.cpp
  PRIMARY #
    system/system.cpp
    controller/controller.cpp
    cartridge/cartridge.cpp
    cpu/cpu.cpp
    tia/tia.cpp
    riot/riot.cpp
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    a26.hpp
    CMakeLists.txt
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    cartridge/cartridge.hpp
    cartridge/serialization.cpp
    cartridge/slot.cpp
    cartridge/slot.hpp
    cartridge/board/atari16k.cpp
    cartridge/board/atari32k.cpp
    cartridge/board/atari8k.cpp
    cartridge/board/board.cpp
    cartridge/board/board.hpp
    cartridge/board/commavid.cpp
    cartridge/board/linear.cpp
    cartridge/board/parker-bros.cpp
    cartridge/board/tigervision.cpp
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    controller/controller.hpp
    controller/port.cpp
    controller/port.hpp
    controller/gamepad/gamepad.cpp
    controller/gamepad/gamepad.hpp
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    cpu/cpu.hpp
    cpu/debugger.cpp
    cpu/memory.cpp
    cpu/serialization.cpp
    cpu/timing.cpp
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    riot/io.cpp
    riot/riot.hpp
    riot/serialization.cpp
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    system/controls.cpp
    system/serialization.cpp
    system/system.hpp
)

ares_add_sources(
  CORE #
    a26
  INCLUDED #
    tia/audio.cpp
    tia/ball.cpp
    tia/color.cpp
    tia/io.cpp
    tia/missile.cpp
    tia/player.cpp
    tia/playfield.cpp
    tia/serialization.cpp
    tia/tia.hpp
    tia/write-queue.cpp
)

=== ares/component/CMakeLists.txt ===
list(REMOVE_DUPLICATES ares.components)

set(ARES_COMPONENTS_LIST "${ares.components}" CACHE STRING "Enabled shared hardware components" FORCE)

mark_as_advanced(ARES_COMPONENTS_LIST)

ares_add_sources(INCLUDED CMakeLists.txt)

macro(component_sources)
  set(options "")
  set(oneValueArgs COMPONENT PRIMARY)
  set(multiValueArgs INCLUDED)

  cmake_parse_arguments(CPS "" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  if(${CPS_COMPONENT} IN_LIST ares.components)
    target_sources(ares PRIVATE ${CPS_PRIMARY})
    foreach(arg IN ITEMS ${CPS_INCLUDED})
      list(APPEND ARES_HEADER_SOURCES "component/${arg}")
      target_sources(ares PRIVATE ${arg})
    endforeach()
  endif()
  set(ARES_HEADER_SOURCES ${ARES_HEADER_SOURCES} PARENT_SCOPE)
endmacro()

component_sources(
  COMPONENT
    ay38910
  PRIMARY
    audio/ay38910/ay38910.cpp
  INCLUDED
    audio/ay38910/ay38910.hpp
    audio/ay38910/serialization.cpp
)

component_sources(
  COMPONENT
    msm5205
  PRIMARY
    audio/msm5205/msm5205.cpp
  INCLUDED
    audio/msm5205/msm5205.hpp
    audio/msm5205/serialization.cpp
)

component_sources(
  COMPONENT
    sn76489
  PRIMARY
    audio/sn76489/sn76489.cpp
  INCLUDED
    audio/sn76489/sn76489.hpp
    audio/sn76489/serialization.cpp
)

component_sources(
  COMPONENT
    t6w28
  PRIMARY
    audio/t6w28/t6w28.cpp
  INCLUDED
    audio/t6w28/t6w28.hpp
    audio/t6w28/serialization.cpp
)

component_sources(
  COMPONENT
    ym2149
  PRIMARY
    audio/ym2149/ym2149.cpp
  INCLUDED
    audio/ym2149/ym2149.hpp
    audio/ym2149/serialization.cpp
)

component_sources(
  COMPONENT
    ym2413
  PRIMARY
    audio/ym2413/ym2413.cpp
  INCLUDED
    audio/ym2413/constants.cpp
    audio/ym2413/io.cpp
    audio/ym2413/operator.cpp
    audio/ym2413/serialization.cpp
    audio/ym2413/voice.cpp
    audio/ym2413/ym2413.hpp
)

component_sources(
  COMPONENT
    ym2612
  PRIMARY
    audio/ym2612/ym2612.cpp
  INCLUDED
    audio/ym2612/channel.cpp
    audio/ym2612/constants.cpp
    audio/ym2612/io.cpp
    audio/ym2612/serialization.cpp
    audio/ym2612/timer.cpp
    audio/ym2612/ym2612.hpp
)

component_sources(
  COMPONENT
    m24c
  PRIMARY
    eeprom/m24c/m24c.cpp
  INCLUDED
    eeprom/m24c/m24c.hpp
    eeprom/m24c/serialization.cpp
)

component_sources(
  COMPONENT
    m93lcx6
  PRIMARY
    eeprom/m93lcx6/m93lcx6.cpp
  INCLUDED
    eeprom/m93lcx6/m93lcx6.hpp
    eeprom/m93lcx6/serialization.cpp
)

component_sources(
  COMPONENT
    i8255
  PRIMARY
    io/i8255/i8255.cpp
  INCLUDED
    io/i8255/i8255.hpp
)

component_sources(
  COMPONENT
    arm7tdmi
  PRIMARY
    processor/arm7tdmi/arm7tdmi.cpp
  INCLUDED
    processor/arm7tdmi/algorithms.cpp
    processor/arm7tdmi/arm7tdmi.hpp
    processor/arm7tdmi/coprocessor.cpp
    processor/arm7tdmi/disassembler.cpp
    processor/arm7tdmi/instruction.cpp
    processor/arm7tdmi/instructions-arm.cpp
    processor/arm7tdmi/instructions-thumb.cpp
    processor/arm7tdmi/memory.cpp
    processor/arm7tdmi/registers.cpp
    processor/arm7tdmi/serialization.cpp
)

component_sources(
  COMPONENT
    gsu
  PRIMARY
    processor/gsu/gsu.cpp
  INCLUDED
    processor/gsu/disassembler.cpp
    processor/gsu/gsu.hpp
    processor/gsu/instruction.cpp
    processor/gsu/instructions.cpp
    processor/gsu/registers.hpp
    processor/gsu/serialization.cpp
)

component_sources(
  COMPONENT
    hg51b
  PRIMARY
    processor/hg51b/hg51b.cpp
  INCLUDED
    processor/hg51b/disassembler.cpp
    processor/hg51b/hg51b.hpp
    processor/hg51b/instruction.cpp
    processor/hg51b/instructions.cpp
    processor/hg51b/registers.cpp
    processor/hg51b/serialization.cpp
)

component_sources(
  COMPONENT
    huc6280
  PRIMARY
    processor/huc6280/huc6280.cpp
  INCLUDED
    processor/huc6280/algorithms.cpp
    processor/huc6280/disassembler.cpp
    processor/huc6280/huc6280.hpp
    processor/huc6280/instruction.cpp
    processor/huc6280/instructions.cpp
    processor/huc6280/memory.cpp
    processor/huc6280/serialization.cpp
)

component_sources(
  COMPONENT
    i8080
  PRIMARY
    processor/i8080/i8080.cpp
  INCLUDED
    processor/i8080/algorithms.cpp
    processor/i8080/disassembler.cpp
    processor/i8080/i8080.hpp
    processor/i8080/instruction.cpp
    processor/i8080/instructions.cpp
    processor/i8080/memory.cpp
    processor/i8080/registers.hpp
    processor/i8080/serialization.cpp
)
component_sources(
  COMPONENT
    m68hc05
  PRIMARY
    processor/m68hc05/m68hc05.cpp
  INCLUDED
    processor/m68hc05/algorithms.cpp
    processor/m68hc05/disassembler.cpp
    processor/m68hc05/instruction.cpp
    processor/m68hc05/instructions.cpp
    processor/m68hc05/m68hc05.hpp
    processor/m68hc05/memory.cpp
    processor/m68hc05/serialization.cpp
)

component_sources(
  COMPONENT
    m68000
  PRIMARY
    processor/m68000/m68000.cpp
  INCLUDED
    processor/m68000/algorithms.cpp
    processor/m68000/conditions.cpp
    processor/m68000/disassembler.cpp
    processor/m68000/effective-address.cpp
    processor/m68000/instruction.cpp
    processor/m68000/instructions.cpp
    processor/m68000/m68000.hpp
    processor/m68000/memory.cpp
    processor/m68000/registers.cpp
    processor/m68000/serialization.cpp
    processor/m68000/traits.cpp
)

component_sources(
  COMPONENT
    mos6502
  PRIMARY
    processor/mos6502/mos6502.cpp
  INCLUDED
    processor/mos6502/addresses.cpp
    processor/mos6502/algorithms.cpp
    processor/mos6502/disassembler.cpp
    processor/mos6502/instruction.cpp
    processor/mos6502/instructions.cpp
    processor/mos6502/memory.cpp
    processor/mos6502/mos6502.hpp
    processor/mos6502/serialization.cpp
)
component_sources(
  COMPONENT
    sh2
  PRIMARY
    processor/sh2/sh2.cpp
  INCLUDED
    processor/sh2/accuracy.hpp
    processor/sh2/decoder.hpp
    processor/sh2/disassembler.cpp
    processor/sh2/exceptions.cpp
    processor/sh2/instruction.cpp
    processor/sh2/instructions.cpp
    processor/sh2/recompiler.cpp
    processor/sh2/serialization.cpp
    processor/sh2/sh2.hpp
    processor/sh2/sh7604/bus.cpp
    processor/sh2/sh7604/cache.cpp
    processor/sh2/sh7604/dma.cpp
    processor/sh2/sh7604/interrupts.cpp
    processor/sh2/sh7604/io.cpp
    processor/sh2/sh7604/serial.cpp
    processor/sh2/sh7604/sh7604.cpp
    processor/sh2/sh7604/sh7604.hpp
    processor/sh2/sh7604/timer.cpp
)

component_sources(
  COMPONENT
    sm5k
  PRIMARY
    processor/sm5k/sm5k.cpp
  INCLUDED
    processor/sm5k/disassembler.cpp
    processor/sm5k/instruction.cpp
    processor/sm5k/instructions.cpp
    processor/sm5k/memory.cpp
    processor/sm5k/serialization.cpp
    processor/sm5k/sm5k.hpp
    processor/sm5k/timer.cpp
)

component_sources(
  COMPONENT
    sm83
  PRIMARY
    processor/sm83/sm83.cpp
  INCLUDED
    processor/sm83/algorithms.cpp
    processor/sm83/disassembler.cpp
    processor/sm83/instruction.cpp
    processor/sm83/instructions.cpp
    processor/sm83/memory.cpp
    processor/sm83/registers.hpp
    processor/sm83/serialization.cpp
    processor/sm83/sm83.hpp
)

component_sources(
  COMPONENT
    spc700
  PRIMARY
    processor/spc700/spc700.cpp
  INCLUDED
    processor/spc700/algorithms.cpp
    processor/spc700/disassembler.cpp
    processor/spc700/instruction.cpp
    processor/spc700/instructions.cpp
    processor/spc700/memory.cpp
    processor/spc700/serialization.cpp
    processor/spc700/spc700.hpp
)

component_sources(
  COMPONENT
    ssp1601
  PRIMARY
    processor/ssp1601/ssp1601.cpp
  INCLUDED
    processor/ssp1601/algorithms.cpp
    processor/ssp1601/disassembler.cpp
    processor/ssp1601/instructions.cpp
    processor/ssp1601/memory.cpp
    processor/ssp1601/registers.cpp
    processor/ssp1601/serialization.cpp
    processor/ssp1601/ssp1601.hpp
)

component_sources(
  COMPONENT
    tlcs900h
  PRIMARY
    processor/tlcs900h/tlcs900h.cpp
  INCLUDED
    processor/tlcs900h/algorithms.cpp
    processor/tlcs900h/conditions.cpp
    processor/tlcs900h/control-registers.cpp
    processor/tlcs900h/disassembler.cpp
    processor/tlcs900h/dma.cpp
    processor/tlcs900h/instruction.cpp
    processor/tlcs900h/instructions.cpp
    processor/tlcs900h/memory.cpp
    processor/tlcs900h/prefetch.cpp
    processor/tlcs900h/registers.cpp
    processor/tlcs900h/serialization.cpp
    processor/tlcs900h/tlcs900h.hpp
)

component_sources(
  COMPONENT
    upd96050
  PRIMARY
    processor/upd96050/upd96050.cpp
  INCLUDED
    processor/upd96050/disassembler.cpp
    processor/upd96050/instructions.cpp
    processor/upd96050/memory.cpp
    processor/upd96050/serialization.cpp
    processor/upd96050/upd96050.hpp
)

component_sources(
  COMPONENT
    v30mz
  PRIMARY
    processor/v30mz/v30mz.cpp
  INCLUDED
    processor/v30mz/algorithms.cpp
    processor/v30mz/disassembler.cpp
    processor/v30mz/instruction.cpp
    processor/v30mz/instructions-adjust.cpp
    processor/v30mz/instructions-alu.cpp
    processor/v30mz/instructions-exec.cpp
    processor/v30mz/instructions-flag.cpp
    processor/v30mz/instructions-group.cpp
    processor/v30mz/instructions-misc.cpp
    processor/v30mz/instructions-move.cpp
    processor/v30mz/instructions-string.cpp
    processor/v30mz/memory.cpp
    processor/v30mz/modrm.cpp
    processor/v30mz/prefetch.cpp
    processor/v30mz/registers.cpp
    processor/v30mz/serialization.cpp
    processor/v30mz/v30mz.hpp
)

component_sources(
  COMPONENT
    wdc65816
  PRIMARY
    processor/wdc65816/wdc65816.cpp
  INCLUDED
    processor/wdc65816/algorithms.cpp
    processor/wdc65816/disassembler.cpp
    processor/wdc65816/instruction.cpp
    processor/wdc65816/instruction.hpp
    processor/wdc65816/instructions-modify.cpp
    processor/wdc65816/instructions-other.cpp
    processor/wdc65816/instructions-pc.cpp
    processor/wdc65816/instructions-read.cpp
    processor/wdc65816/instructions-write.cpp
    processor/wdc65816/memory.cpp
    processor/wdc65816/registers.hpp
    processor/wdc65816/serialization.cpp
    processor/wdc65816/wdc65816.hpp
)

component_sources(
  COMPONENT
    z80
  PRIMARY
    processor/z80/z80.cpp
  INCLUDED
    processor/z80/algorithms.cpp
    processor/z80/disassembler.cpp
    processor/z80/instruction.cpp
    processor/z80/instructions.cpp
    processor/z80/memory.cpp
    processor/z80/registers.hpp
    processor/z80/serialization.cpp
    processor/z80/z80.hpp
)

component_sources(
  COMPONENT
    s3511a
  PRIMARY
    rtc/s3511a/s3511a.cpp
  INCLUDED
    rtc/s3511a/s3511a.hpp
    rtc/s3511a/serialization.cpp
)

component_sources(
  COMPONENT
    sst39sf0x0
  PRIMARY
    flash/sst39sf0x0/sst39sf0x0.cpp
  INCLUDED
    flash/sst39sf0x0/sst39sf0x0.hpp
)

component_sources(
  COMPONENT
    tms9918
  PRIMARY
    video/tms9918/tms9918.cpp
  INCLUDED
    video/tms9918/background.cpp
    video/tms9918/dac.cpp
    video/tms9918/io.cpp
    video/tms9918/serialization.cpp
    video/tms9918/sprite.cpp
    video/tms9918/tms9918.hpp
)

component_sources(
  COMPONENT
    v9938
  PRIMARY
    video/v9938/v9938.cpp
  INCLUDED
    video/v9938/background.cpp
    video/v9938/commands.cpp
    video/v9938/dac.cpp
    video/v9938/io.cpp
    video/v9938/serialization.cpp
    video/v9938/sprite.cpp
    video/v9938/v9938.hpp
)

=== ares/cv/CMakeLists.txt ===
ares_components(z80 tms9918 sn76489)

ares_add_sources(
  CORE #
    cv
  UNITY #
    cv.cpp
  PRIMARY #
    cpu/cpu.cpp
    vdp/vdp.cpp
    psg/psg.cpp
    system/system.cpp
    cartridge/cartridge.cpp
    controller/controller.cpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    cv.hpp
    CMakeLists.txt
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    cartridge/cartridge.hpp
    cartridge/serialization.cpp
    cartridge/slot.cpp
    cartridge/slot.hpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    cartridge/board/board.cpp
    cartridge/board/board.hpp
    cartridge/board/coleco.cpp
    cartridge/board/megacart.cpp
    cartridge/board/xin1.cpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    controller/controller.hpp
    controller/port.cpp
    controller/port.hpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    controller/gamepad/gamepad.cpp
    controller/gamepad/gamepad.hpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    cpu/cpu.hpp
    cpu/debugger.cpp
    cpu/memory.cpp
    cpu/serialization.cpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    psg/psg.hpp
    psg/serialization.cpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    system/controls.cpp
    system/serialization.cpp
    system/system.hpp
)

ares_add_sources(
  CORE #
    cv
  INCLUDED #
    vdp/color.cpp
    vdp/serialization.cpp
    vdp/vdp.hpp
)

=== debian/changelog ===
ares (147+dfsg-2) unstable; urgency=medium

  [ Alexandre Detiste ]
  * Team upload.
  * add debian/salsa-ci.yml
  * wrap-and-sort -ast
  * drop duplicated debhelper build-dep
  * drop "Rules-Requires-Root: no": it is the default now

  [ Christopher Obbard ]
  * d/control: Use gtksourceview4 instead of gtksourceview3 (Closes: #1079407)

  [ David James ]
  * Expand man page

 -- Christopher Obbard <obbardc@debian.org>  Wed, 28 Jan 2026 17:46:54 +0000

ares (147+dfsg-1) unstable; urgency=medium

  * Updated d/watch to version 5
  * Updated SDL dependency to libsdl3-dev
  * Converted d/patches to use new CMake build system
  * updated debian/* to use CMake
  * Bump package standards version to 4.7.3

 -- David James <davidjamescastor215@proton.me>  Mon, 05 Jan 2026 19:27:49 +0000

=== debian/control ===
Source: ares
Section: otherosfs
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 David James <davidjamescastor215@proton.me>,
 Tobias Hansen <thansen@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libao-dev,
 libasound2-dev [linux-any],
 libchdr-dev,
 libgtk-3-dev,
 libgtksourceview-4-dev,
 libopenal-dev,
 libpulse-dev,
 libsdl3-dev,
 libudev-dev [linux-any],
 libxv-dev,
 pkgconf,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/games-team/ares
Vcs-Git: https://salsa.debian.org/games-team/ares.git
Homepage: https://ares-emu.net

Package: ares
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 nes-emulator,
Description: Accurate multi-system emulator
 ares is an emulator for systems from Atari, Nintendo, Sega, Sony, NEC, SNK,
 Microsoft, Coleco, Bandai and Benesse. It is a descendent of higan and bsnes
 and focuses on accuracy and preservation. The SNES emulation is especially
 complete and polished.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all qa=+all

DEB_BUILD_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU)

# DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

CMAKE_OPTIONS := \
	-DARES_BUILD_LOCAL=OFF \
	-DARES_ENABLE_MINIMUM_CPU=OFF \
	-DARES_SKIP_DEPS=ON \
	-DARES_VERSION_OVERRIDE="v$(DEB_VERSION)" \
	-DWITH_SYSTEM_ZLIB=ON

cores := a26;fc;sfc;sg;ms;ps1;pce;ng;msx;cv;myvision;gb;gba;ws;ngp;spec
# Reimplementation of older disable-md-on-32bit.patch
ifneq ($(shell $(CXX) -E -dM - < /dev/null | grep INT128),)
	cores += ;md
endif

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    BUILDOPT=RelWithDebInfo
else
    BUILDOPT=Debug
endif

# Enforce Debian microarchitecture baseline on amd64
# Reimplementation of no-optional-extensions.patch
ifeq ($(DEB_HOST_ARCH_CPU),amd64)
	export DEB_CFLAGS_MAINT_APPEND=-march=x86-64
	export DEB_CXXFLAGS_MAINT_APPEND=-march=x86-64
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	$(CMAKE_OPTIONS) \
	-DCMAKE_BUILD_TYPE=$(BUILDOPT) \
	-DARES_CORES="$(cores)"

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/\+dfsg\d*//
Owner: ares-emulator
Project: ares
Repack: yes
Repacksuffix: +dfsg
